diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index d7e4749..e01a9ec 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -934,52 +741,23 @@ cl5ImportLDIF(const char *clDir, const char *ldifFile, Replica **replicas)
             goto next;
         }
 
-        if (!replicas || _cl5ReplicaInList(replica, replicas)) {
-            /* write operation creates the file if it does not exist */
-            rc = _cl5WriteOperation(replica_get_name(replica),
-                                    replGen, &op, 1);
-            if (rc != CL5_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                              "cl5ImportLDIF - "
-                              "Failed to write operation to the changelog: "
-                              "type: %lu, dn: %s\n",
-                              op.operation_type, REPL_GET_DN(&op.target_address));
-                slapi_ch_free_string(&replGen);
-                operation_parameters_done(&op);
-                goto done;
-            }
-            entryCount++;
-        }
     next:
         slapi_ch_free_string(&replGen);
         operation_parameters_done(&op);
     }
 
     /* Set RUVs and entry count */
-    file_obj = objset_first_obj(s_cl5Desc.dbFiles);
-    while (file_obj) {
-        dbfile = (CL5DBFile *)object_get_data(file_obj);
-        if (0 == strcasecmp(dbfile->replName, replica_get_name(prim_replica))) {
-            break;
-        }
-        dbfile = NULL;
-        file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
-    }
-
-    if (dbfile) {
+    if (cldb) {
         if (purgeidx > 0) {
-            ruv_destroy(&dbfile->purgeRUV);
-            rc = ruv_init_from_bervals(purgevals, &dbfile->purgeRUV);
+            ruv_destroy(&cldb->purgeRUV);
+            rc = ruv_init_from_bervals(purgevals, &cldb->purgeRUV);
         }
         if (maxidx > 0) {
-            ruv_destroy(&dbfile->maxRUV);
-            rc = ruv_init_from_bervals(maxvals, &dbfile->maxRUV);
+            ruv_destroy(&cldb->maxRUV);
+            rc = ruv_init_from_bervals(maxvals, &cldb->maxRUV);
         }
 
-        dbfile->entryCount = entryCount;
-    }
-    if (file_obj) {
-        object_release(file_obj);
+        cldb->entryCount = entryCount;
     }
 
 done:
@@ -1018,60 +796,64 @@ cl5GetState()
    Description:    sets changelog trimming parameters; changelog must be open.
    Parameters:  maxEntries - maximum number of entries in the chnagelog (in all files);
                 maxAge - maximum entry age;
-                compactInterval - interval to compact changelog db;
                 trimInterval - changelog trimming interval.
    Return:        CL5_SUCCESS if successful;
                 CL5_BAD_STATE if changelog is not open
  */
 int
-cl5ConfigTrimming(int maxEntries, const char *maxAge, int compactInterval, int trimInterval)
+cl5ConfigTrimming(Replica *replica, int maxEntries, const char *maxAge, int trimInterval)
 {
+    int isTrimmingEnabledBefore = 0;
+    int isTrimmingEnabledAfter = 0;
+    cldb_Handle *cldb = replica_get_file_info(replica);
+
     if (s_cl5Desc.dbState == CL5_STATE_NONE) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5ConfigTrimming - Changelog is not initialized\n");
         return CL5_BAD_STATE;
     }
 
-    /* make sure changelog is not closed while trimming configuration
-       is updated.*/
-    if (CL5_SUCCESS != _cl5AddThread()) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "cl5ConfigTrimming - Could not start changelog trimming thread\n");
-        return CL5_BAD_STATE;
-    }
+    slapi_counter_increment(cldb->clThreads);
+    /* make sure changelog is not closed while trimming configuration is updated.*/
+
+    PR_Lock(cldb->clLock); 
 
-    PR_Lock(s_cl5Desc.dbTrim.lock);
+    isTrimmingEnabledBefore = cldb_IsTrimmingEnabled(cldb);
 
     if (maxAge) {
         /* don't ignore this argument */
         if (strcmp(maxAge, CL5_STR_IGNORE) != 0) {
-            s_cl5Desc.dbTrim.maxAge = slapi_parse_duration(maxAge);
+            cldb->clConf.maxAge = slapi_parse_duration(maxAge);
         }
     } else {
         /* unlimited */
-        s_cl5Desc.dbTrim.maxAge = 0;
+        cldb->clConf.maxAge = 0;
     }
 
     if (maxEntries != CL5_NUM_IGNORE) {
-        s_cl5Desc.dbTrim.maxEntries = maxEntries;
-    }
-
-    if (compactInterval != CL5_NUM_IGNORE) {
-        s_cl5Desc.dbTrim.compactInterval = compactInterval;
+        cldb->clConf.maxEntries = maxEntries;
     }
 
     if (trimInterval != CL5_NUM_IGNORE) {
-        s_cl5Desc.dbTrim.trimInterval = trimInterval;
+        cldb->clConf.trimInterval = trimInterval;
     }
 
-    /* The config was updated, notify the changelog trimming thread */
-    PR_Lock(s_cl5Desc.clLock);
-    PR_NotifyCondVar(s_cl5Desc.clCvar);
-    PR_Unlock(s_cl5Desc.clLock);
+    isTrimmingEnabledAfter = cldb_IsTrimmingEnabled(cldb);
 
-    PR_Unlock(s_cl5Desc.dbTrim.lock);
+    if (isTrimmingEnabledAfter && !isTrimmingEnabledBefore) {
+        /* start trimming */
+        cldb_StartTrimming(replica);
+    } else if (!isTrimmingEnabledAfter && isTrimmingEnabledBefore) {
+        /* stop trimming */
+        cldb_StopTrimming(replica, NULL);
+    } else {
+        /* The config was updated, notify the changelog trimming thread */
+        PR_NotifyCondVar(cldb->clCvar);
+    }
 
-    _cl5RemoveThread();
+    PR_Unlock(cldb->clLock);
+
+    slapi_counter_decrement(cldb->clThreads);
 
     return CL5_SUCCESS;
 }
@@ -1093,8 +875,11 @@ cl5DestroyIterator(void *iterator)
     if (it->cursor)
         it->cursor->c_close(it->cursor);
 
+    /* NOTE (LK) locking of CL files  ?*/
+    /*
     if (it->file)
         object_release(it->file);
+    */
 
     slapi_ch_free((void **)&it);
 }
@@ -1107,7 +892,6 @@ cl5DestroyIterator(void *iterator)
                    replica object since generation can change while operation
                    is in progress (if the data is reloaded). !!!
                 op - operation to write
-                local - this is a non-replicated operation
                 txn - the transaction containing this operation
    Return:        CL5_SUCCESS if function is successfull;
                 CL5_BAD_DATA if invalid op is passed;
@@ -1116,7 +900,7 @@ cl5DestroyIterator(void *iterator)
                 CL5_DB_ERROR if any other db error occured;
  */
 int
-cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local, void *txn)
+cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, void *txn)
 {
     int rc;
 
@@ -1138,23 +922,16 @@ cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_oper
     }
 
     /* make sure that changelog is open while operation is in progress */
-    rc = _cl5AddThread();
-    if (rc != CL5_SUCCESS)
-        return rc;
+    slapi_counter_increment(cldb->clThreads);
 
-    rc = _cl5WriteOperationTxn(replName, replGen, op, local, txn);
+    rc = _cl5WriteOperationTxn(cldb, op, txn);
 
     /* update the upper bound ruv vector */
     if (rc == CL5_SUCCESS) {
-        Object *file_obj = NULL;
-
-        if (_cl5GetDBFileByReplicaName(replName, replGen, &file_obj) == CL5_SUCCESS) {
-            rc = _cl5UpdateRUV(file_obj, op->csn, PR_FALSE, PR_FALSE);
-            object_release(file_obj);
-        }
+        rc = _cl5UpdateRUV(cldb, op->csn, PR_FALSE, PR_FALSE);
     }
 
-    _cl5RemoveThread();
+    slapi_counter_decrement(cldb->clThreads);
 
     return rc;
 }
@@ -1167,7 +944,6 @@ cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_oper
                    replica object since generation can change while operation
                    is in progress (if the data is reloaded). !!!
                 op - operation to write
-                local - this is a non-replicated operation
    Return:        CL5_SUCCESS if function is successfull;
                 CL5_BAD_DATA if invalid op is passed;
                 CL5_BAD_STATE if db has not been initialized;
@@ -1175,9 +951,9 @@ cl5WriteOperationTxn(const char *replName, const char *replGen, const slapi_oper
                 CL5_DB_ERROR if any other db error occured;
  */
 int
-cl5WriteOperation(const char *replName, const char *replGen, const slapi_operation_parameters *op, PRBool local)
+cl5WriteOperation(cldb_Handle *cldb, const slapi_operation_parameters *op)
 {
-    return cl5WriteOperationTxn(replName, replGen, op, local, NULL);
+    return cl5WriteOperationTxn(cldb, op, NULL);
 }
 
 /* Name:        cl5CreateReplayIterator
@@ -1218,7 +994,6 @@ cl5CreateReplayIteratorEx(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL
 {
     int rc;
     Replica *replica;
-    Object *file_obj = NULL;
 
     replica = prp->replica;
     if (replica == NULL || consumerRuv == NULL || iterator == NULL) {
@@ -1240,22 +1015,11 @@ cl5CreateReplayIteratorEx(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL
     if (rc != CL5_SUCCESS)
         return rc;
 
-
-    rc = _cl5GetDBFile(replica, &file_obj);
-    if (rc == CL5_SUCCESS && file_obj) {
-        /* iterate through the ruv in csn order to find first master for which
-           we can replay changes */
-
-        rc = _cl5PositionCursorForReplay(consumerRID, consumerRuv, replica, file_obj, iterator, NULL);
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5CreateReplayIteratorEx - Could not find DB object for replica\n");
-    }
+    /* iterate through the ruv in csn order to find first master for which 
+       we can replay changes */		    
+    rc = _cl5PositionCursorForReplay (consumerRID, consumerRuv, replica, iterator, NULL);
 
     if (rc != CL5_SUCCESS) {
-        if (file_obj) {
-            object_release(file_obj);
-        }
         /* release the thread */
         _cl5RemoveThread();
     }
@@ -1275,7 +1039,6 @@ cl5CreateReplayIterator(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL5R
 
     int rc;
     Replica *replica;
-    Object *file_obj = NULL;
 
     replica = prp->replica;
     if (replica == NULL || consumerRuv == NULL || iterator == NULL) {
@@ -1297,28 +1060,18 @@ cl5CreateReplayIterator(Private_Repl_Protocol *prp, const RUV *consumerRuv, CL5R
     if (rc != CL5_SUCCESS)
         return rc;
 
-
-    rc = _cl5GetDBFile(replica, &file_obj);
-    if (rc == CL5_SUCCESS && file_obj) {
-        /* iterate through the ruv in csn order to find first master for which
-           we can replay changes */
-        ReplicaId consumerRID = agmt_get_consumer_rid(prp->agmt, prp->conn);
-        int continue_on_missing = agmt_get_ignoremissing(prp->agmt);
-        int save_cont_miss = continue_on_missing;
-        rc = _cl5PositionCursorForReplay(consumerRID, consumerRuv, replica, file_obj, iterator, &continue_on_missing);
-        if (save_cont_miss == 1 && continue_on_missing == 0) {
-            /* the option to continue once on a missing csn was used, rest */
-            agmt_set_ignoremissing(prp->agmt, 0);
-        }
-    } else {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5CreateReplayIterator - Could not find DB object for replica\n");
+    /* iterate through the ruv in csn order to find first master for which
+       we can replay changes */
+    ReplicaId consumerRID = agmt_get_consumer_rid(prp->agmt, prp->conn);
+    int continue_on_missing = agmt_get_ignoremissing(prp->agmt);
+    int save_cont_miss = continue_on_missing;
+    rc = _cl5PositionCursorForReplay(consumerRID, consumerRuv, replica, iterator, &continue_on_missing);
+    if (save_cont_miss == 1 && continue_on_missing == 0) {
+        /* the option to continue once on a missing csn was used, rest */
+        agmt_set_ignoremissing(prp->agmt, 0);
     }
 
     if (rc != CL5_SUCCESS) {
-        if (file_obj)
-            object_release(file_obj);
-
         /* release the thread */
         _cl5RemoveThread();
     }
@@ -1396,7 +1149,7 @@ cl5GetNextOperationToReplay(CL5ReplayIterator *iterator, CL5Entry *entry)
 
     /* there is an entry we should return */
     /* Callers of this function should cl5_operation_parameters_done(op) */
-    if (0 != cl5DBData2Entry(data, datalen, entry)) {
+    if (0 != cl5DBData2Entry(data, datalen, entry, iterator->it_cldb->clcrypt_handle)) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                       "cl5GetNextOperationToReplay - %s - Failed to format entry rc=%d\n", agmt_name, rc);
         return rc;
@@ -1421,10 +1174,12 @@ cl5DestroyReplayIterator(CL5ReplayIterator **iterator)
 
     clcache_return_buffer(&(*iterator)->clcache);
 
-    if ((*iterator)->fileObj) {
-        object_release((*iterator)->fileObj);
-        (*iterator)->fileObj = NULL;
+    /* TBD (LK) lock/unlock cldb ?
+     if ((*iterator)->it_cldb) {
+        object_release((*iterator)->it_cldb);
+        (*iterator)->it_cldb = NULL;
     }
+    */
 
     /* release supplier's ruv */
     if ((*iterator)->supplierRuvObj) {
@@ -1438,50 +1193,6 @@ cl5DestroyReplayIterator(CL5ReplayIterator **iterator)
     _cl5RemoveThread();
 }
 
-/* Name:        cl5DeleteOnClose
-   Description:    marks changelog for deletion when it is closed
-   Parameters:  flag; if flag = 1 then delete else don't
-   Return:        none
- */
-void
-cl5DeleteOnClose(PRBool rm)
-{
-    s_cl5Desc.dbRmOnClose = rm;
-}
-
-/* Name:        cl5GetDir
-   Description:    returns changelog directory
-   Parameters:  none
-   Return:        copy of the directory; caller needs to free the string
- */
-char *
-cl5GetDir()
-{
-    if (s_cl5Desc.dbDir == NULL) {
-        return NULL;
-    } else {
-        return slapi_ch_strdup(s_cl5Desc.dbDir);
-    }
-}
-
-/* Name: cl5Exist
-   Description: checks if a changelog exists in the specified directory;
-                We consider changelog to exist if it contains the dbversion file.
-   Parameters: clDir - directory to check
-   Return: 1 - if changelog exists; 0 - otherwise
- */
-PRBool
-cl5Exist(const char *clDir)
-{
-    char fName[MAXPATHLEN + 1];
-    int rc;
-
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s", clDir, VERSION_FILE);
-    rc = PR_Access(fName, PR_ACCESS_EXISTS);
-
-    return (rc == PR_SUCCESS);
-}
-
 /* Name: cl5GetOperationCount
    Description: returns number of entries in the changelog. The changelog must be
                 open for the value to be meaningful.
@@ -1493,8 +1204,6 @@ cl5Exist(const char *clDir)
 int
 cl5GetOperationCount(Replica *replica)
 {
-    Object *file_obj;
-    CL5DBFile *file;
     int count = 0;
     int rc;
 
@@ -1511,6 +1220,7 @@ cl5GetOperationCount(Replica *replica)
 
     if (replica == NULL) /* compute total entry count */
     {
+        /* TBD (LK) get count for all backends
         file_obj = objset_first_obj(s_cl5Desc.dbFiles);
         while (file_obj) {
             file = (CL5DBFile *)object_get_data(file_obj);
@@ -1518,22 +1228,18 @@ cl5GetOperationCount(Replica *replica)
             count += file->entryCount;
             file_obj = objset_next_obj(s_cl5Desc.dbFiles, file_obj);
         }
+        */
+        count = 0;
     } else /* return count for particular db */
     {
-        /* select correct db file */
-        rc = _cl5GetDBFile(replica, &file_obj);
-        if (rc == CL5_SUCCESS) {
-            file = (CL5DBFile *)object_get_data(file_obj);
-            PR_ASSERT(file);
-
-            count = file->entryCount;
-            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                          "cl5GetOperationCount - Found DB object %p\n", file_obj);
-            object_release(file_obj);
+        cldb_Handle *cldb = replica_get_file_info(replica);
+        if (cldb) {
+            count = cldb->entryCount;
         } else {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                           "cl5GetOperationCount - Could not get DB object for replica\n");
-            count = 0;
+            /* replica is not enabled */
+            count = -1;
         }
     }
 
@@ -1545,49 +1251,11 @@ cl5GetOperationCount(Replica *replica)
 
 /* this call happens under state lock */
 static int
-_cl5Open(const char *dir, const CL5DBConfig *config, CL5OpenMode openMode)
+_cl5Open(CL5OpenMode openMode)
 {
     int rc;
 
-    PR_ASSERT(dir);
-
-    /* setup db configuration parameters */
-    if (config) {
-        _cl5SetDBConfig(config);
-    } else {
-        _cl5SetDefaultDBConfig();
-    }
-
-    /* initialize trimming */
-    rc = _cl5TrimInit();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Open - Failed to initialize trimming\n");
-        goto done;
-    }
-
-    /* create the changelog directory if it does not exist */
-    rc = cl5CreateDirIfNeeded(dir);
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Open - Failed to create changelog directory (%s)\n", dir);
-        goto done;
-    }
-
-    if (s_cl5Desc.dbDir) {
-        slapi_ch_free_string(&s_cl5Desc.dbDir);
-    }
-    s_cl5Desc.dbDir = slapi_ch_strdup(dir);
-
-    /* check database version */
-    rc = _cl5CheckDBVersion();
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5Open - Invalid db version\n");
-        goto done;
-    }
-
     s_cl5Desc.dbOpenMode = openMode;
-
     /* initialize db environment */
     rc = _cl5AppInit();
     if (rc != CL5_SUCCESS) {
@@ -1596,8 +1264,10 @@ _cl5Open(const char *dir, const CL5DBConfig *config, CL5OpenMode openMode)
         goto done;
     }
 
+    replica_enumerate_replicas(cldb_SetReplicaDB, NULL);
+	
     /* init the clcache */
-    if ((clcache_init(&s_cl5Desc.dbEnv) != 0)) {
+    if ((clcache_init() != 0)) {
         rc = CL5_SYSTEM_ERROR;
         goto done;
     }
@@ -1621,55 +1291,183 @@ done:;
 }
 
 int
-cl5CreateDirIfNeeded(const char *dirName)
+cldb_UnSetReplicaDB(Replica *replica, void *arg)
 {
-    int rc;
-    char buff[MAXPATHLEN + 1];
-    char *t;
+    int rc = 0;
+    cldb_Handle *cldb = replica_get_file_info(replica);
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+ 
+    if (cldb == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "cldb_UnSetReplicaDB: cldb is NULL\n");
+        return -1;
+    }
 
-    PR_ASSERT(dirName);
+    cldb->flags &= ~DB_FILE_ACTIVE;
 
-    rc = PR_Access(dirName, PR_ACCESS_EXISTS);
-    if (rc == PR_SUCCESS) {
-        return CL5_SUCCESS;
+    /* cleanup trimming */
+    cldb_StopThreads(replica, NULL);
+
+    /* write or cleanup changelog ruvs */
+    if (s_cl5Desc.dbState == CL5_STATE_CLOSING) {
+        _cl5WriteReplicaRUV(replica, NULL);
+    } else {
+        ruv_destroy(&cldb->maxRUV);
+        ruv_destroy(&cldb->purgeRUV);
     }
 
-    /* directory does not exist - try to create */
-    PL_strncpyz(buff, dirName, sizeof(buff) - 1);
-    t = strchr(buff, '/');
+    if (cldb->clLock != NULL) {
+        PR_DestroyLock(cldb->clLock);
+        cldb->clLock = NULL;
+    }
+    if (cldb->clCvar != NULL) {
+        PR_DestroyCondVar(cldb->clCvar);
+        cldb->clCvar = NULL;
+    }
+    /* Clear the cl encryption data (if configured) */
+    rc = clcrypt_destroy(cldb->clcrypt_handle, be);
 
-    /* skip first slash */
-    if (t) {
-        t = strchr(t + 1, '/');
+    if (cldb->flags & ~DB_FILE_DONE) {
+        _cldb_DeleteDB(replica);
     }
 
-    while (t) {
-        *t = '\0';
-        if (PR_Access(buff, PR_ACCESS_EXISTS) != PR_SUCCESS) {
-            rc = PR_MkDir(buff, DIR_CREATE_MODE);
-            if (rc != PR_SUCCESS) {
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                              "cl5CreateDirIfNeeded - Failed to create dir (%s); NSPR error - %d\n",
-                              dirName, PR_GetError());
-                return CL5_SYSTEM_ERROR;
-            }
-        }
+    slapi_counter_destroy(&cldb->clThreads);
 
-        *t++ = FILE_PATHSEP;
+    rc = replica_set_file_info(replica, NULL);
+    slapi_ch_free_string(&cldb->ident);
+    slapi_ch_free((void **)&cldb);
 
-        t = strchr(t, '/');
+    return rc;
+}
+
+int
+cldb_SetReplicaDB(Replica *replica, void *arg)
+{
+    DB *pDB = NULL;
+    cldb_Handle *cldb = NULL;
+
+    if (!replica_is_flag_set(replica, REPLICA_LOG_CHANGES)) {
+        /* replica does not have a changelog */
+        return 0;
+    }
+    cldb = replica_get_file_info(replica);
+    if (cldb) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "cldb_SetReplicaDB - DB already set to replica\n");
+        return 0;
     }
 
-    /* last piece */
-    rc = PR_MkDir(buff, DIR_CREATE_MODE);
-    if (rc != PR_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "cl5CreateDirIfNeeded - Failed to create dir; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+    Object *ruv_obj = replica_get_ruv(replica);
+    int rc = -1;
+ 
+    rc = slapi_back_get_info(be, BACK_INFO_DBENV_CLDB, (void **)&pDB);
+    if (rc == 0) {
+        cldb = (cldb_Handle *)slapi_ch_calloc(1, sizeof(cldb_Handle));
+        cldb->db = pDB;
+        cldb->ident = ruv_get_replica_generation ((RUV*)object_get_data (ruv_obj));
+        _cl5ReadRUV(cldb, PR_TRUE);
+        _cl5ReadRUV(cldb, PR_FALSE);
+        _cl5GetEntryCount(cldb);
     }
+    object_release(ruv_obj);
 
-    return CL5_SUCCESS;
+    cldb->clThreads = slapi_counter_new();
+
+    cldb->flags = DB_FILE_ACTIVE;
+    rc = replica_set_file_info(replica, cldb);
+
+    if ((cldb->clLock = PR_NewLock()) == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "cldb_SetReplicaDB - Failed to create on close lock; NSPR error - %d\n",
+                      PR_GetError());
+        return CL5_SYSTEM_ERROR;
+    }
+    if ((cldb->clCvar = PR_NewCondVar(cldb->clLock)) == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "cldb_SetReplicaDB - Failed to create on close cvar; NSPR error - %d\n",
+                      PR_GetError());
+        return CL5_SYSTEM_ERROR;
+    }
+
+    /* get cl configuration for backend */
+    back_info_config_entry config_entry;
+    config_entry.dn = "cn=changelog";
+    changelog5Config config = {};
+    rc = slapi_back_ctrl_info(be, BACK_INFO_CLDB_GET_CONFIG, (void *)&config_entry);
+    changelog5_extract_config(config_entry.ce, &config);
+    changelog5_register_config_callbacks(slapi_entry_get_dn_const(config_entry.ce), replica);
+    slapi_entry_free(config_entry.ce);
+
+    /* set trimming parameters */
+    rc = cl5ConfigTrimming(replica, config.maxEntries, config.maxAge, config.trimInterval);
+    if (rc != CL5_SUCCESS) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "cldb_SetReplicaDB - failed to configure changelog trimming\n");
+        return CL5_BAD_DATA;
+    }
+
+    /* Set the cl encryption algorithm (if configured) */
+    if (config.encryptionAlgorithm) {
+        cldb->clConf.encryptionAlgorithm = config.encryptionAlgorithm;
+        cldb->clcrypt_handle = clcrypt_init(config.encryptionAlgorithm, be);
+    }
+    changelog5_config_done(&config);
+
+    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+        "cldb_SetReplicaDB: cldb is set\n");
+ 
+    return rc;
+}
+
+static int
+cldb_IsTrimmingEnabled(cldb_Handle *cldb)
+{
+    if ((cldb->clConf.maxAge != 0 || cldb->clConf.maxEntries != 0) &&  cldb->clConf.trimInterval > 0) {
+        return 1;
+    } else {
+        return 0;
+    }
+}
+
+int
+cldb_StartTrimming(Replica *replica)
+{
+    return _cl5DispatchTrimThread(replica);
+}
+int
+cldb_StopTrimming(Replica *replica, void *arg)
+{
+    cldb_Handle *cldb = replica_get_file_info(replica);
+
+    /* we need to stop the changelog threads - trimming or purging */
+    PR_Lock(cldb->clLock);
+    PR_NotifyCondVar(cldb->clCvar);
+    PR_Unlock(cldb->clLock);
+
+    return 0;
+}
+
+int
+cldb_StopThreads(Replica *replica, void *arg)
+{
+    cldb_Handle *cldb = replica_get_file_info(replica);
+    PRIntervalTime interval;
+    uint64_t threads;
+
+    /* we need to stop the changelog threads - trimming or purging */
+    PR_Lock(cldb->clLock);
+    PR_NotifyCondVar(cldb->clCvar);
+    PR_Unlock(cldb->clLock);
+
+    interval = PR_MillisecondsToInterval(100);
+    while ((threads = slapi_counter_get_value(cldb->clThreads)) > 0) {
+        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
+                      "_cl5Close -Waiting for threads to exit: %lu thread(s) still active\n",
+                      threads);
+         DS_Sleep(interval);
+    }
+    return 0;
 }
 
 static int
@@ -1677,39 +1475,25 @@ _cl5AppInit(void)
 {
     int rc = -1; /* initialize to failure */
     DB_ENV *dbEnv = NULL;
-    uint32_t pagesize = 0;
-    int openflags = 0;
     char *cookie = NULL;
     Slapi_Backend *be = slapi_get_first_backend(&cookie);
     while (be) {
         rc = slapi_back_get_info(be, BACK_INFO_DBENV, (void **)&dbEnv);
         if ((LDAP_SUCCESS == rc) && dbEnv) {
-            rc = slapi_back_get_info(be,
-                                     BACK_INFO_INDEXPAGESIZE, (void **)&pagesize);
-            if ((LDAP_SUCCESS == rc) && pagesize) {
-                rc = slapi_back_get_info(be,
-                                         BACK_INFO_DBENV_OPENFLAGS, (void **)&openflags);
-                if (LDAP_SUCCESS == rc) {
                     break; /* Successfully fetched */
-                }
-            }
         }
         be = slapi_get_next_backend(cookie);
     }
     slapi_ch_free((void **)&cookie);
 
-    if (rc == 0 && dbEnv && pagesize) {
+    if (rc == 0 && dbEnv) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
                       "_cl5AppInit - Fetched backend dbEnv (%p)\n", dbEnv);
         s_cl5Desc.dbEnv = dbEnv;
-        s_cl5Desc.dbEnvOpenFlags = openflags;
-        s_cl5Desc.dbConfig.pageSize = pagesize;
         return CL5_SUCCESS;
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "_cl5AppInit - Failed to fetch backend dbenv (%p) and/or "
-                      "index page size (%lu)\n",
-                      dbEnv, (long unsigned int)pagesize);
+                      "_cl5AppInit - Failed to fetch backend dbenv\n");
         return CL5_DB_ERROR;
     }
 }
@@ -1717,79 +1501,6 @@ _cl5AppInit(void)
 static int
 _cl5DBOpen()
 {
-    PRBool dbFile;
-    PRDir *dir;
-    PRDirEntry *entry = NULL;
-    int rc = -1; /* initialize to failure */
-    Replica *replica;
-    int count = 0;
-
-    /* create lock that guarantees that each file is only added once to the list */
-    s_cl5Desc.fileLock = PR_NewLock();
-
-    /* loop over all db files and open them; file name format is cl5_<dbid>.<dbext>    */
-    dir = PR_OpenDir(s_cl5Desc.dbDir);
-    if (dir == NULL) {
-        slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5DBOpen - Failed to open changelog dir; NSPR error - %d\n",
-                      PR_GetError());
-        return CL5_SYSTEM_ERROR;
-    }
-
-    /* initialize set of db file objects */
-    s_cl5Desc.dbFiles = objset_new(NULL);
-    while (NULL != (entry = PR_ReadDir(dir, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == entry->name) {
-            break;
-        }
-
-        dbFile = _cl5FileName2Replica(entry->name, &replica);
-        if (dbFile) /* this is db file, not a log or dbversion; those are just skipped */
-        {
-            /* we only open files for existing replicas */
-            if (replica) {
-                rc = _cl5DBOpenFile(replica, NULL /* file object */,
-                                    PR_FALSE /* check for duplicates */);
-                if (rc != CL5_SUCCESS) {
-                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBOpen - "
-                                                                       "Error opening file %s\n",
-                                  entry->name);
-                    return rc;
-                }
-                count++;
-            } else /* there is no matching replica for the file - remove */
-            {
-                char fullpathname[MAXPATHLEN];
-                slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBOpen - "
-                                                                   "File %s has no matching replica; removing\n",
-                              entry->name);
-
-                PR_snprintf(fullpathname, MAXPATHLEN, "%s/%s", s_cl5Desc.dbDir, entry->name);
-                rc = s_cl5Desc.dbEnv->dbremove(s_cl5Desc.dbEnv,
-                                               0, fullpathname, 0,
-                                               DEFAULT_DB_ENV_OP_FLAGS);
-                if (rc != 0) {
-                    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                                  "_cl5DBOpen - Failed to remove (%s) file; "
-                                  "libdb error - %d (%s)\n",
-                                  fullpathname, rc, db_strerror(rc));
-                    if (PR_Delete(fullpathname) != PR_SUCCESS) {
-                        PRErrorCode prerr = PR_GetError();
-                        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                                      "_cl5DBOpen - Failed to remove (%s) file; "
-                                      "nspr error - %d (%s)\n",
-                                      fullpathname, prerr, slapd_pr_strerror(prerr));
-                    }
-                }
-            }
-        }
-    }
-
-    slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl, "_cl5DBOpen - "
-                                                       "Opened %d existing databases in %s\n",
-                  count, s_cl5Desc.dbDir);
-    PR_CloseDir(dir);
-
     return CL5_SUCCESS;
 }
 
@@ -1808,7 +1519,7 @@ _cl5DBOpen()
    <4 byte value size><value1><4 byte value size><value2>
 */
 static int
-_cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
+_cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len, void *clcrypt_handle)
 {
     int size = 1 /* version */ + 1 /* operation type */ + sizeof(time_t);
     char *pos;
@@ -1835,7 +1546,7 @@ _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
         slapi_entry2mods(op->p.p_add.target_entry, &rawDN /* dn */, &add_mods);
         size += strlen(rawDN) + 1;
         /* Need larger buffer for the encrypted changelog */
-        if (s_cl5Desc.clcrypt_handle) {
+        if (clcrypt_handle) {
             size += (_cl5GetModsSize(add_mods) * (1 + BACK_CRYPT_OUTBUFF_EXTLEN));
         } else {
             size += _cl5GetModsSize(add_mods);
@@ -1845,7 +1556,7 @@ _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
     case SLAPI_OPERATION_MODIFY:
         size += REPL_GET_DN_LEN(&op->target_address) + 1;
         /* Need larger buffer for the encrypted changelog */
-        if (s_cl5Desc.clcrypt_handle) {
+        if (clcrypt_handle) {
             size += (_cl5GetModsSize(op->p.p_modify.modify_mods) * (1 + BACK_CRYPT_OUTBUFF_EXTLEN));
         } else {
             size += _cl5GetModsSize(op->p.p_modify.modify_mods);
@@ -1865,7 +1576,7 @@ _cl5Entry2DBData(const CL5Entry *entry, char **data, PRUint32 *len)
         else
             size++; /* for NULL char */
         /* Need larger buffer for the encrypted changelog */
-        if (s_cl5Desc.clcrypt_handle) {
+        if (clcrypt_handle) {
             size += (_cl5GetModsSize(op->p.p_modrdn.modrdn_mods) * (1 + BACK_CRYPT_OUTBUFF_EXTLEN));
         } else {
             size += _cl5GetModsSize(op->p.p_modrdn.modrdn_mods);
